.586
.model flat,stdcall
option casemap:none

include     fcalldemo.inc
include     counter.asm

.data

fmt1         db "%d cycles, STDCALL %c",0
fmt2         db "%d cycles, FASTCALL %c",0

.data?

buffer      db 100 dup(?)

.code

stdcall1 PROC a:DWORD,b:DWORD,c:DWORD,d:DWORD

    mov     eax,a
    add     eax,b
    add     eax,c
    add     eax,d
    ret

stdcall1 ENDP

fastcall1 PROC FASTCALL a:DWORD,b:DWORD,c:DWORD,d:DWORD

    mov     eax,a
    add     eax,b
    add     eax,c
    add     eax,d
    ret

fastcall1 ENDP

stdcall2 PROC a:DWORD,b:DWORD

    mov     eax,a
    add     eax,b
    ret

stdcall2 ENDP

fastcall2 PROC FASTCALL a:DWORD,b:DWORD

    mov     eax,a
    add     eax,b
    ret

fastcall2 ENDP

start:

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke  stdcall1,10,20,30,40
    ctr_end
    invoke  wsprintf,ADDR buffer,ADDR fmt1,eax,10
    invoke  StdOut,ADDR buffer

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke  fastcall1,10,20,30,40
    ctr_end
    invoke  wsprintf,ADDR buffer,ADDR fmt2,eax,10
    invoke  StdOut,ADDR buffer

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke  stdcall2,10,20
    ctr_end
    invoke  wsprintf,ADDR buffer,ADDR fmt1,eax,10
    invoke  StdOut,ADDR buffer

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke  fastcall2,10,20
    ctr_end
    invoke  wsprintf,ADDR buffer,ADDR fmt2,eax,10
    invoke  StdOut,ADDR buffer

    invoke  ExitProcess,0

END start